--- //depot/projects/trustedbsd/mac/sys/security/mac_biba/mac_biba.c	2003/06/02 12:26:58
+++ //depot/user/hdandeka/rishi_SystemVIPC/sys/security/mac_biba/mac_biba.c	2003/06/13 16:12:32
@@ -60,6 +60,10 @@
 #include <sys/socketvar.h>
 #include <sys/pipe.h>
 #include <sys/sysctl.h>
+#include <sys/msg.h>
+#include <sys/msg_msg.h>
+#include <sys/sem.h>
+#include <sys/shm.h>
 
 #include <fs/devfs/devfs.h>
 
@@ -1151,6 +1155,58 @@
 }
 
 /*
+ * Labeling event operations: System V IPC objects.
+ */
+
+static void
+mac_biba_create_ipc_msgmsg(struct ucred *cred, struct msg *msgptr,
+								    struct label *msglabel)
+{
+	struct mac_biba *source, *dest;
+
+	source = SLOT(&cred->cr_label);
+	dest = SLOT(msglabel);
+
+	mac_biba_copy_single(source, dest);
+}   
+
+static void 
+mac_biba_create_ipc_msgqueue(struct ucred *cred, struct msqid_kernel *msqkptr,
+								    struct label *msqlabel)
+{
+	struct mac_biba *source, *dest;
+
+	source = SLOT(&cred->cr_label);
+	dest = SLOT(msqlabel);
+
+	mac_biba_copy_single(source, dest);
+}
+
+static void
+mac_biba_create_ipc_sema(struct ucred *cred, struct semid_kernel *semakptr,
+								    struct label *semalabel)
+{
+	struct mac_biba *source, *dest;
+
+	source = SLOT(&cred->cr_label);
+	dest = SLOT(semalabel);
+
+	mac_biba_copy_single(source, dest);
+}
+
+static void
+mac_biba_create_ipc_shm(struct ucred *cred, struct shmid_kernel *shmsegptr,
+								    struct label *shmlabel)
+{
+	struct mac_biba *source, *dest;
+
+	source = SLOT(&cred->cr_label);
+	dest = SLOT(shmlabel);
+
+	mac_biba_copy_single(source, dest);
+}
+
+/*
  * Labeling event operations: network objects.
  */
 static void
@@ -1427,6 +1483,33 @@
 }
 
 /*
+ * Label cleanup/flush operations
+ */
+static void 
+mac_biba_cleanup_ipc_msgmsg(struct label *msglabel)
+{
+				bzero(SLOT(msglabel), sizeof(struct mac_biba));
+}
+
+static void 
+mac_biba_cleanup_ipc_msgqueue(struct label *msqlabel)
+{
+				bzero(SLOT(msqlabel), sizeof(struct mac_biba));
+}
+
+static void 
+mac_biba_cleanup_ipc_sema(struct label *semalabel)
+{
+				bzero(SLOT(semalabel), sizeof(struct mac_biba));
+}
+
+static void 
+mac_biba_cleanup_ipc_shm(struct label *shmlabel)
+{
+				bzero(SLOT(shmlabel), sizeof(struct mac_biba));
+}
+
+/*
  * Access control checks.
  */
 static int
@@ -1588,7 +1671,294 @@
 	return (mac_biba_single_in_range(p, i) ? 0 : EACCES);
 }
 
+    
+static int
+mac_biba_check_ipc_msgrcv(struct ucred *cred, struct msg *msgptr)
+{   
+
+	struct mac_biba *subj, *obj;
+
+	if (!mac_biba_enabled)
+		return (0);
+
+	subj = SLOT(&cred->cr_label);
+	obj = SLOT(&msgptr->label);
+
+	if (!mac_biba_dominate_single(obj, subj))
+		return (EACCES);
+
+	return (0);
+}
+
+static int
+mac_biba_check_ipc_msgrmid(struct ucred *cred, struct msg *msgptr)
+{   
+
+	struct mac_biba *subj, *obj;
+
+	if (!mac_biba_enabled)
+		return (0);
+
+	subj = SLOT(&cred->cr_label);
+	obj = SLOT(&msgptr->label);
+
+	if (!mac_biba_dominate_single(subj, obj))
+		return (EACCES);
+
+	return (0);
+}
+
+static int
+mac_biba_check_ipc_msqget(struct ucred *cred, struct msqid_kernel *msqkptr)
+{
+	struct mac_biba *subj, *obj;
+
+	if (!mac_biba_enabled)
+		return (0);
+
+	subj = SLOT(&cred->cr_label);
+	obj = SLOT(&msqkptr->label);
+
+	if (!mac_biba_dominate_single(obj, subj))
+		return (EACCES);
+
+	return (0);
+}
+
+
+static int
+mac_biba_check_ipc_msqsnd(struct ucred *cred, struct msqid_kernel *msqkptr)
+{
+	struct mac_biba *subj, *obj;
+
+	if (!mac_biba_enabled)
+		return (0);
+
+	subj = SLOT(&cred->cr_label);
+	obj = SLOT(&msqkptr->label);
+
+	if (!mac_biba_dominate_single(subj, obj))
+		return (EACCES);
+
+	return (0);
+}
+
+static int
+mac_biba_check_ipc_msqrcv(struct ucred *cred, struct msqid_kernel *msqkptr)
+{
+	struct mac_biba *subj, *obj;
+
+	if (!mac_biba_enabled)
+		return (0);
+
+	subj = SLOT(&cred->cr_label);
+	obj = SLOT(&msqkptr->label);
+
+	if (!mac_biba_dominate_single(obj, subj))
+		return (EACCES);
+
+	return (0);
+}
+
+
+static int
+mac_biba_check_ipc_msqctl(struct ucred *cred, struct msqid_kernel *msqkptr,
+								                    int cmd)
+{
+	struct mac_biba *subj, *obj;
+
+	if (!mac_biba_enabled)
+		return (0);
+
+	subj = SLOT(&cred->cr_label);
+	obj = SLOT(&msqkptr->label);
+	switch(cmd) {
+					case IPC_RMID:
+					case IPC_SET:
+						if (!mac_biba_dominate_single(subj, obj))
+							return (EACCES);
+						break;
+					case IPC_STAT:
+						if (!mac_biba_dominate_single(obj, subj))
+							return (EACCES);
+						break;
+					default:
+						return (EACCES);
+	}
+	return (0);
+}
+
 static int
+mac_biba_check_ipc_semctl(struct ucred *cred, struct semid_kernel *semakptr,
+								                    int cmd)
+{
+	struct mac_biba *subj, *obj;
+
+	if (!mac_biba_enabled)
+		return (0);
+
+	subj = SLOT(&cred->cr_label);
+	obj = SLOT(&semakptr->label);
+	switch(cmd) {
+					case IPC_RMID:
+					case IPC_SET:
+					case SETVAL:
+					case SETALL:
+						if (!mac_biba_dominate_single(subj, obj))
+							return (EACCES);
+						break;
+					case IPC_STAT:
+					case GETVAL:
+					case GETPID:
+					case GETNCNT:
+					case GETZCNT:
+					case GETALL:
+						if (!mac_biba_dominate_single(obj, subj))
+							return (EACCES);
+						break;
+					default:
+						return (EACCES);
+	}
+	return (0);
+}
+
+
+static int
+mac_biba_check_ipc_semget(struct ucred *cred, struct semid_kernel *semakptr)
+{
+	struct mac_biba *subj, *obj;
+
+	if (!mac_biba_enabled)
+		return (0);
+
+	subj = SLOT(&cred->cr_label);
+	obj = SLOT(&semakptr->label);
+
+	if (!mac_biba_dominate_single(obj, subj))
+		return (EACCES);
+
+	return (0);
+}
+
+
+static int
+mac_biba_check_ipc_semop(struct ucred *cred, struct semid_kernel *semakptr,
+								                        size_t accesstype)
+{
+	struct mac_biba *subj, *obj;
+
+	if (!mac_biba_enabled)
+		return (0);
+
+	subj = SLOT(&cred->cr_label);
+	obj = SLOT(&semakptr->label);
+
+	if( accesstype & SEM_R )
+		if (!mac_biba_dominate_single(obj, subj))
+			return (EACCES);
+
+	if( accesstype & SEM_A )
+		if (!mac_biba_dominate_single(subj, obj))
+			return (EACCES);
+
+	return (0);
+ 
+}
+
+static int
+mac_biba_check_ipc_shmat(struct ucred *cred, struct shmid_kernel *shmsegptr,
+								                        int shmflg)
+{
+	struct mac_biba *subj, *obj;
+
+	if (!mac_biba_enabled)
+		return (0);
+
+	subj = SLOT(&cred->cr_label);
+	obj = SLOT(&shmsegptr->label);
+
+	if (!mac_biba_dominate_single(obj, subj))
+			return (EACCES);
+	if ((shmflg & SHM_RDONLY) == 0) 
+		if (!mac_biba_dominate_single(subj, obj))
+			return (EACCES);
+	
+	return (0);
+}
+
+static int
+mac_biba_check_ipc_shmctl(struct ucred *cred, struct shmid_kernel *shmsegptr,
+								                        int cmd)
+{
+	struct mac_biba *subj, *obj;
+
+	if (!mac_biba_enabled)
+		return (0);
+
+	subj = SLOT(&cred->cr_label);
+	obj = SLOT(&shmsegptr->label);
+	switch(cmd) {
+					case IPC_RMID:
+					case IPC_SET:
+						if (!mac_biba_dominate_single(subj, obj))
+							return (EACCES);
+						break;
+					case IPC_STAT:
+					case SHM_STAT:
+						if (!mac_biba_dominate_single(obj, subj))
+							return (EACCES);
+						break;
+					default:
+						return (EACCES);
+	}
+	return (0);
+}
+
+#if 0
+
+/* 
+ * TODO: Do we check the integrity of the implicit write access caused
+ * by the bookkeeping tasks associated with the shmdt call, which may 
+ * modify/delete the shmseg meta-data and/or the shared segment itself? 
+ */
+
+static int
+mac_biba_check_ipc_shmdt(struct ucred *cred, struct shmid_kernel *shmsegptr)
+{
+	struct mac_biba *subj, *obj;
+
+	if (!mac_biba_enabled)
+		return (0);
+
+	subj = SLOT(&cred->cr_label);
+	obj = SLOT(&shmsegptr->label);
+
+	if (!mac_biba_dominate_single(subj, obj))
+		return (EACCES);
+	
+	return (0);
+}
+#endif
+
+static int
+mac_biba_check_ipc_shmget(struct ucred *cred, struct shmid_kernel *shmsegptr,
+								                         int shmflg)
+{
+	struct mac_biba *subj, *obj;
+
+	if (!mac_biba_enabled)
+		return (0);
+
+	subj = SLOT(&cred->cr_label);
+	obj = SLOT(&shmsegptr->label);
+
+	if (!mac_biba_dominate_single(obj, subj))
+		return (EACCES);
+
+	return (0);
+}
+
+static int
 mac_biba_check_kld_load(struct ucred *cred, struct vnode *vp,
     struct label *label)
 {
@@ -2667,6 +3037,10 @@
 	.mpo_init_cred_label = mac_biba_init_label,
 	.mpo_init_devfsdirent_label = mac_biba_init_label,
 	.mpo_init_ifnet_label = mac_biba_init_label,
+	.mpo_init_ipc_msgmsg_label = mac_biba_init_label,
+  .mpo_init_ipc_msgqueue_label = mac_biba_init_label,
+  .mpo_init_ipc_sema_label = mac_biba_init_label,
+  .mpo_init_ipc_shm_label = mac_biba_init_label,
 	.mpo_init_ipq_label = mac_biba_init_label_waitcheck,
 	.mpo_init_mbuf_label = mac_biba_init_label_waitcheck,
 	.mpo_init_mount_label = mac_biba_init_label,
@@ -2679,6 +3053,10 @@
 	.mpo_destroy_cred_label = mac_biba_destroy_label,
 	.mpo_destroy_devfsdirent_label = mac_biba_destroy_label,
 	.mpo_destroy_ifnet_label = mac_biba_destroy_label,
+	.mpo_destroy_ipc_msgmsg_label = mac_biba_destroy_label,
+  .mpo_destroy_ipc_msgqueue_label = mac_biba_destroy_label,
+  .mpo_destroy_ipc_sema_label = mac_biba_destroy_label,
+  .mpo_destroy_ipc_shm_label = mac_biba_destroy_label,
 	.mpo_destroy_ipq_label = mac_biba_destroy_label,
 	.mpo_destroy_mbuf_label = mac_biba_destroy_label,
 	.mpo_destroy_mount_label = mac_biba_destroy_label,
@@ -2725,6 +3103,10 @@
 	.mpo_create_datagram_from_ipq = mac_biba_create_datagram_from_ipq,
 	.mpo_create_fragment = mac_biba_create_fragment,
 	.mpo_create_ifnet = mac_biba_create_ifnet,
+	.mpo_create_ipc_msgmsg = mac_biba_create_ipc_msgmsg,
+  .mpo_create_ipc_msgqueue = mac_biba_create_ipc_msgqueue,
+  .mpo_create_ipc_sema = mac_biba_create_ipc_sema,
+  .mpo_create_ipc_shm = mac_biba_create_ipc_shm,
 	.mpo_create_ipq = mac_biba_create_ipq,
 	.mpo_create_mbuf_from_mbuf = mac_biba_create_mbuf_from_mbuf,
 	.mpo_create_mbuf_linklayer = mac_biba_create_mbuf_linklayer,
@@ -2739,11 +3121,28 @@
 	.mpo_create_proc0 = mac_biba_create_proc0,
 	.mpo_create_proc1 = mac_biba_create_proc1,
 	.mpo_relabel_cred = mac_biba_relabel_cred,
+	.mpo_cleanup_ipc_msgmsg = mac_biba_cleanup_ipc_msgmsg,
+	.mpo_cleanup_ipc_msgqueue = mac_biba_cleanup_ipc_msgqueue,
+	.mpo_cleanup_ipc_sema = mac_biba_cleanup_ipc_sema,
+	.mpo_cleanup_ipc_shm = mac_biba_cleanup_ipc_shm,
 	.mpo_check_bpfdesc_receive = mac_biba_check_bpfdesc_receive,
 	.mpo_check_cred_relabel = mac_biba_check_cred_relabel,
 	.mpo_check_cred_visible = mac_biba_check_cred_visible,
 	.mpo_check_ifnet_relabel = mac_biba_check_ifnet_relabel,
 	.mpo_check_ifnet_transmit = mac_biba_check_ifnet_transmit,
+  .mpo_check_ipc_msgrcv = mac_biba_check_ipc_msgrcv,
+	.mpo_check_ipc_msgrmid = mac_biba_check_ipc_msgrmid,
+  .mpo_check_ipc_msqget = mac_biba_check_ipc_msqget,
+  .mpo_check_ipc_msqsnd = mac_biba_check_ipc_msqsnd,
+  .mpo_check_ipc_msqrcv = mac_biba_check_ipc_msqrcv,
+  .mpo_check_ipc_msqctl = mac_biba_check_ipc_msqctl,
+  .mpo_check_ipc_semctl = mac_biba_check_ipc_semctl,
+  .mpo_check_ipc_semget = mac_biba_check_ipc_semget,
+  .mpo_check_ipc_semop = mac_biba_check_ipc_semop,
+  .mpo_check_ipc_shmat = mac_biba_check_ipc_shmat,
+  .mpo_check_ipc_shmctl = mac_biba_check_ipc_shmctl,
+/* .mpo_check_ipc_shmdt = mac_biba_check_ipc_shmdt, */
+  .mpo_check_ipc_shmget = mac_biba_check_ipc_shmget,
 	.mpo_check_kld_load = mac_biba_check_kld_load,
 	.mpo_check_kld_unload = mac_biba_check_kld_unload,
 	.mpo_check_mount_stat = mac_biba_check_mount_stat,
--- //depot/projects/trustedbsd/mac/sys/security/mac_lomac/mac_lomac.c	2003/06/02 12:26:58
+++ //depot/user/hdandeka/rishi_SystemVIPC/sys/security/mac_lomac/mac_lomac.c	2003/06/13 18:14:49
@@ -60,6 +60,10 @@
 #include <sys/pipe.h>
 #include <sys/sysctl.h>
 #include <sys/syslog.h>
+#include <sys/msg.h>
+#include <sys/msg_msg.h>
+#include <sys/sem.h>
+#include <sys/shm.h>
 
 #include <fs/devfs/devfs.h>
 
@@ -1223,6 +1227,59 @@
 }
 
 /*
+ * Labeling event operations: System V IPC objects.
+ */
+
+static void
+mac_lomac_create_ipc_msgmsg(struct ucred *cred, struct msg *msgptr,
+								    struct label *msglabel)
+{
+	struct mac_lomac *source, *dest;
+
+	source = SLOT(&cred->cr_label);
+	dest = SLOT(msglabel);
+
+	mac_lomac_copy_single(source, dest);
+}   
+
+static void 
+mac_lomac_create_ipc_msgqueue(struct ucred *cred, struct msqid_kernel *msqkptr,
+								    struct label *msqlabel)
+{
+	struct mac_lomac *source, *dest;
+
+	source = SLOT(&cred->cr_label);
+	dest = SLOT(msqlabel);
+
+	mac_lomac_copy_single(source, dest);
+}
+
+static void
+mac_lomac_create_ipc_sema(struct ucred *cred, struct semid_kernel *semakptr,
+								    struct label *semalabel)
+{
+	struct mac_lomac *source, *dest;
+
+	source = SLOT(&cred->cr_label);
+	dest = SLOT(semalabel);
+
+	mac_lomac_copy_single(source, dest);
+}
+
+static void
+mac_lomac_create_ipc_shm(struct ucred *cred, struct shmid_kernel *shmsegptr,
+								    struct label *shmlabel)
+{
+	struct mac_lomac *source, *dest;
+
+	source = SLOT(&cred->cr_label);
+	dest = SLOT(shmlabel);
+
+	mac_lomac_copy_single(source, dest);
+}
+
+
+/*
  * Labeling event operations: network objects.
  */
 static void
@@ -1568,6 +1625,34 @@
 }
 
 /*
+ * Label cleanup/flush operations
+ */
+static void 
+mac_lomac_cleanup_ipc_msgmsg(struct label *msglabel)
+{
+				bzero(SLOT(msglabel), sizeof(struct mac_lomac));
+}
+
+static void 
+mac_lomac_cleanup_ipc_msgqueue(struct label *msqlabel)
+{
+				bzero(SLOT(msqlabel), sizeof(struct mac_lomac));
+}
+
+static void 
+mac_lomac_cleanup_ipc_sema(struct label *semalabel)
+{
+				bzero(SLOT(semalabel), sizeof(struct mac_lomac));
+}
+
+static void 
+mac_lomac_cleanup_ipc_shm(struct label *shmlabel)
+{
+				bzero(SLOT(shmlabel), sizeof(struct mac_lomac));
+}
+
+
+/*
  * Access control checks.
  */
 static int
@@ -1742,6 +1827,292 @@
 }
 
 static int
+mac_lomac_check_ipc_msgrcv(struct ucred *cred, struct msg *msgptr)
+{   
+
+	struct mac_lomac *subj, *obj;
+
+	if (!mac_lomac_enabled)
+		return (0);
+
+	subj = SLOT(&cred->cr_label);
+	obj = SLOT(&msgptr->label);
+
+	if (!mac_lomac_dominate_single(obj, subj))
+		return (maybe_demote(subj, obj, "msgrcv", "msg", NULL));
+
+	return (0);
+}
+
+static int
+mac_lomac_check_ipc_msgrmid(struct ucred *cred, struct msg *msgptr)
+{   
+
+	struct mac_lomac *subj, *obj;
+
+	if (!mac_lomac_enabled)
+		return (0);
+
+	subj = SLOT(&cred->cr_label);
+	obj = SLOT(&msgptr->label);
+
+	if (!mac_lomac_dominate_single(subj, obj))
+		return (EACCES);
+
+	return (0);
+}
+
+static int
+mac_lomac_check_ipc_msqget(struct ucred *cred, struct msqid_kernel *msqkptr)
+{
+	struct mac_lomac *subj, *obj;
+
+	if (!mac_lomac_enabled)
+		return (0);
+
+	subj = SLOT(&cred->cr_label);
+	obj = SLOT(&msqkptr->label);
+
+	if (!mac_lomac_dominate_single(obj, subj))
+		return (maybe_demote(subj, obj, "msqget", "msg", NULL));
+
+	return (0);
+}
+
+
+static int
+mac_lomac_check_ipc_msqsnd(struct ucred *cred, struct msqid_kernel *msqkptr)
+{
+	struct mac_lomac *subj, *obj;
+
+	if (!mac_lomac_enabled)
+		return (0);
+
+	subj = SLOT(&cred->cr_label);
+	obj = SLOT(&msqkptr->label);
+
+	if (!mac_lomac_dominate_single(subj, obj))
+		return (EACCES);
+
+	return (0);
+}
+
+static int
+mac_lomac_check_ipc_msqrcv(struct ucred *cred, struct msqid_kernel *msqkptr)
+{
+	struct mac_lomac *subj, *obj;
+
+	if (!mac_lomac_enabled)
+		return (0);
+
+	subj = SLOT(&cred->cr_label);
+	obj = SLOT(&msqkptr->label);
+
+	if (!mac_lomac_dominate_single(obj, subj))
+		return (maybe_demote(subj, obj, "msqrcv", "msg", NULL));
+
+	return (0);
+}
+
+
+static int
+mac_lomac_check_ipc_msqctl(struct ucred *cred, struct msqid_kernel *msqkptr,
+								                    int cmd)
+{
+	struct mac_lomac *subj, *obj;
+
+	if (!mac_lomac_enabled)
+		return (0);
+
+	subj = SLOT(&cred->cr_label);
+	obj = SLOT(&msqkptr->label);
+	switch(cmd) {
+					case IPC_RMID:
+					case IPC_SET:
+						if (!mac_lomac_dominate_single(subj, obj))
+							return (EACCES);
+						break;
+					case IPC_STAT:
+						if (!mac_lomac_dominate_single(obj, subj))
+							return (maybe_demote(subj, obj, "msqctl", "msg", NULL));
+						break;
+					default:
+						return (EACCES);
+	}
+	return (0);
+}
+
+static int
+mac_lomac_check_ipc_semctl(struct ucred *cred, struct semid_kernel *semakptr,
+								                    int cmd)
+{
+	struct mac_lomac *subj, *obj;
+
+	if (!mac_lomac_enabled)
+		return (0);
+
+	subj = SLOT(&cred->cr_label);
+	obj = SLOT(&semakptr->label);
+	switch(cmd) {
+					case IPC_RMID:
+					case IPC_SET:
+					case SETVAL:
+					case SETALL:
+						if (!mac_lomac_dominate_single(subj, obj))
+							return (EACCES);
+						break;
+					case IPC_STAT:
+					case GETVAL:
+					case GETPID:
+					case GETNCNT:
+					case GETZCNT:
+					case GETALL:
+						if (!mac_lomac_dominate_single(obj, subj))
+							return (maybe_demote(subj, obj, "semctl", "sem", NULL));
+						break;
+					default:
+						return (EACCES);
+	}
+	return (0);
+}
+
+
+static int
+mac_lomac_check_ipc_semget(struct ucred *cred, struct semid_kernel *semakptr)
+{
+	struct mac_lomac *subj, *obj;
+
+	if (!mac_lomac_enabled)
+		return (0);
+
+	subj = SLOT(&cred->cr_label);
+	obj = SLOT(&semakptr->label);
+
+	if (!mac_lomac_dominate_single(obj, subj))
+		return (maybe_demote(subj, obj, "semget", "sem", NULL));
+
+	return (0);
+}
+
+
+static int
+mac_lomac_check_ipc_semop(struct ucred *cred, struct semid_kernel *semakptr,
+								                        size_t accesstype)
+{
+	struct mac_lomac *subj, *obj;
+
+	if (!mac_lomac_enabled)
+		return (0);
+
+	subj = SLOT(&cred->cr_label);
+	obj = SLOT(&semakptr->label);
+
+	if( accesstype & SEM_R )
+		if (!mac_lomac_dominate_single(obj, subj))
+			return (maybe_demote(subj, obj, "semop", "sem", NULL));
+
+	if( accesstype & SEM_A )
+		if (!mac_lomac_dominate_single(subj, obj))
+			return (EACCES);
+
+	return (0);
+ 
+}
+
+static int
+mac_lomac_check_ipc_shmat(struct ucred *cred, struct shmid_kernel *shmsegptr,
+								                        int shmflg)
+{
+	struct mac_lomac *subj, *obj;
+
+	if (!mac_lomac_enabled)
+		return (0);
+
+	subj = SLOT(&cred->cr_label);
+	obj = SLOT(&shmsegptr->label);
+
+	if (!mac_lomac_dominate_single(obj, subj))
+			return (maybe_demote(subj, obj, "shmat", "shm", NULL));
+	if ((shmflg & SHM_RDONLY) == 0) 
+		if (!mac_lomac_dominate_single(subj, obj))
+			return (EACCES);
+	
+	return (0);
+}
+
+static int
+mac_lomac_check_ipc_shmctl(struct ucred *cred, struct shmid_kernel *shmsegptr,
+								                        int cmd)
+{
+	struct mac_lomac *subj, *obj;
+
+	if (!mac_lomac_enabled)
+		return (0);
+
+	subj = SLOT(&cred->cr_label);
+	obj = SLOT(&shmsegptr->label);
+	switch(cmd) {
+					case IPC_RMID:
+					case IPC_SET:
+						if (!mac_lomac_dominate_single(subj, obj))
+							return (EACCES);
+						break;
+					case IPC_STAT:
+					case SHM_STAT:
+						if (!mac_lomac_dominate_single(obj, subj))
+							return (maybe_demote(subj, obj, "shmctl", "shm", NULL));
+						break;
+					default:
+						return (EACCES);
+	}
+	return (0);
+}
+
+#if 0
+
+/* 
+ * TODO: Do we check the integrity of the implicit write access caused
+ * by the bookkeeping tasks associated with the shmdt call, which may 
+ * modify/delete the shmseg meta-data and/or the shared segment itself? 
+ */
+
+static int
+mac_lomac_check_ipc_shmdt(struct ucred *cred, struct shmid_kernel *shmsegptr)
+{
+	struct mac_lomac *subj, *obj;
+
+	if (!mac_lomac_enabled)
+		return (0);
+
+	subj = SLOT(&cred->cr_label);
+	obj = SLOT(&shmsegptr->label);
+
+	if (!mac_lomac_dominate_single(subj, obj))
+		return (EACCES);
+	
+	return (0);
+}
+#endif
+
+static int
+mac_lomac_check_ipc_shmget(struct ucred *cred, struct shmid_kernel *shmsegptr,
+								                         int shmflg)
+{
+	struct mac_lomac *subj, *obj;
+
+	if (!mac_lomac_enabled)
+		return (0);
+
+	subj = SLOT(&cred->cr_label);
+	obj = SLOT(&shmsegptr->label);
+
+	if (!mac_lomac_dominate_single(obj, subj))
+		return (maybe_demote(subj, obj, "shmget", "shm", NULL));
+
+	return (0);
+}
+
+static int
 mac_lomac_check_kld_load(struct ucred *cred, struct vnode *vp,
     struct label *label)
 {
@@ -2606,6 +2977,10 @@
 	.mpo_init_cred_label = mac_lomac_init_label,
 	.mpo_init_devfsdirent_label = mac_lomac_init_label,
 	.mpo_init_ifnet_label = mac_lomac_init_label,
+	.mpo_init_ipc_msgmsg_label = mac_lomac_init_label,
+  .mpo_init_ipc_msgqueue_label = mac_lomac_init_label,
+  .mpo_init_ipc_sema_label = mac_lomac_init_label,
+  .mpo_init_ipc_shm_label = mac_lomac_init_label,
 	.mpo_init_ipq_label = mac_lomac_init_label_waitcheck,
 	.mpo_init_mbuf_label = mac_lomac_init_label_waitcheck,
 	.mpo_init_mount_label = mac_lomac_init_label,
@@ -2619,6 +2994,10 @@
 	.mpo_destroy_cred_label = mac_lomac_destroy_label,
 	.mpo_destroy_devfsdirent_label = mac_lomac_destroy_label,
 	.mpo_destroy_ifnet_label = mac_lomac_destroy_label,
+	.mpo_destroy_ipc_msgmsg_label = mac_lomac_destroy_label,
+  .mpo_destroy_ipc_msgqueue_label = mac_lomac_destroy_label,
+  .mpo_destroy_ipc_sema_label = mac_lomac_destroy_label,
+  .mpo_destroy_ipc_shm_label = mac_lomac_destroy_label,
 	.mpo_destroy_ipq_label = mac_lomac_destroy_label,
 	.mpo_destroy_mbuf_label = mac_lomac_destroy_label,
 	.mpo_destroy_mount_label = mac_lomac_destroy_label,
@@ -2667,6 +3046,10 @@
 	.mpo_create_datagram_from_ipq = mac_lomac_create_datagram_from_ipq,
 	.mpo_create_fragment = mac_lomac_create_fragment,
 	.mpo_create_ifnet = mac_lomac_create_ifnet,
+	.mpo_create_ipc_msgmsg = mac_lomac_create_ipc_msgmsg,
+  .mpo_create_ipc_msgqueue = mac_lomac_create_ipc_msgqueue,
+  .mpo_create_ipc_sema = mac_lomac_create_ipc_sema,
+  .mpo_create_ipc_shm = mac_lomac_create_ipc_shm,
 	.mpo_create_ipq = mac_lomac_create_ipq,
 	.mpo_create_mbuf_from_mbuf = mac_lomac_create_mbuf_from_mbuf,
 	.mpo_create_mbuf_linklayer = mac_lomac_create_mbuf_linklayer,
@@ -2684,11 +3067,29 @@
 	.mpo_create_proc0 = mac_lomac_create_proc0,
 	.mpo_create_proc1 = mac_lomac_create_proc1,
 	.mpo_relabel_cred = mac_lomac_relabel_cred,
+	.mpo_cleanup_ipc_msgmsg = mac_lomac_cleanup_ipc_msgmsg,
+	.mpo_cleanup_ipc_msgqueue = mac_lomac_cleanup_ipc_msgqueue,
+	.mpo_cleanup_ipc_sema = mac_lomac_cleanup_ipc_sema,
+	.mpo_cleanup_ipc_shm = mac_lomac_cleanup_ipc_shm,
 	.mpo_check_bpfdesc_receive = mac_lomac_check_bpfdesc_receive,
 	.mpo_check_cred_relabel = mac_lomac_check_cred_relabel,
 	.mpo_check_cred_visible = mac_lomac_check_cred_visible,
 	.mpo_check_ifnet_relabel = mac_lomac_check_ifnet_relabel,
 	.mpo_check_ifnet_transmit = mac_lomac_check_ifnet_transmit,
+/* .mpo_check_ipc_msgmsq = mac_lomac_check_ipc_msgmsq, */
+  .mpo_check_ipc_msgrcv = mac_lomac_check_ipc_msgrcv,
+	.mpo_check_ipc_msgrmid = mac_lomac_check_ipc_msgrmid,
+  .mpo_check_ipc_msqget = mac_lomac_check_ipc_msqget,
+  .mpo_check_ipc_msqsnd = mac_lomac_check_ipc_msqsnd,
+  .mpo_check_ipc_msqrcv = mac_lomac_check_ipc_msqrcv,
+  .mpo_check_ipc_msqctl = mac_lomac_check_ipc_msqctl,
+  .mpo_check_ipc_semctl = mac_lomac_check_ipc_semctl,
+  .mpo_check_ipc_semget = mac_lomac_check_ipc_semget,
+  .mpo_check_ipc_semop = mac_lomac_check_ipc_semop,
+  .mpo_check_ipc_shmat = mac_lomac_check_ipc_shmat,
+  .mpo_check_ipc_shmctl = mac_lomac_check_ipc_shmctl,
+/* .mpo_check_ipc_shmdt = mac_lomac_check_ipc_shmdt, */
+  .mpo_check_ipc_shmget = mac_lomac_check_ipc_shmget,
 	.mpo_check_kld_load = mac_lomac_check_kld_load,
 	.mpo_check_kld_unload = mac_lomac_check_kld_unload,
 	.mpo_check_pipe_ioctl = mac_lomac_check_pipe_ioctl,
